/*
  sdt/session.cpp

  Copyright (c) 2021 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include "session.h"

namespace ACN::SDT {

/**
 * @brief SessionId::operator == sessionID comparitor
 * @param other
 * @return
 */
bool SessionId::operator== (const SessionId & other) const {
  return ((other.cid == cid) &
          (other.number == number) &
          (other.protocol == protocol));
}


/**
 * @brief Session::Session
 */
Session::Session() {

}


/**
 * @brief Session::~Session & leaves the session gracefully.
 */
Session::~Session() {
  // TODO: Disconnect the session.
}


/**
 * @brief Session::id
 * @return
 */
SessionId Session::id() {
  SessionId ret;
  ret.cid = leader->cid();
  ret.number = number_;
  ret.protocol = protocol_;
  return ret;
}


/**
 * @brief Session::join_accept
 */
void Session::join_accept()
{

}


/**
 * @brief Session::join_refuse
 */
void Session::join_refuse()
{

}


/**
 * @brief Session::leaving
 */
void Session::leaving()
{

}


/**
 * @brief Session::nak
 */
void Session::nak()
{

}


/**
 * @brief Session::reliable_wrapper
 */
void Session::reliable_wrapper()
{

}


/**
 * @brief Session::unreliable_wrapper
 */
void Session::unreliable_wrapper()
{

}


/**
 * @brief Session::ack
 */
void Session::ack()
{

}


/**
 * @brief Session::channel_params
 */
void Session::channel_params()
{

}


/**
 * @brief Session::leave
 */
void Session::leave()
{

}


/**
 * @brief Session::connect
 */
void Session::connect()
{

}


/**
 * @brief Session::connect_accept
 */
void Session::connect_accept()
{

}


/**
 * @brief Session::connect_refuse
 */
void Session::connect_refuse()
{

}


/**
 * @brief Session::disconnect
 */
void Session::disconnect()
{

}


/**
 * @brief Session::disconnecting
 */
void Session::disconnecting()
{

}

} // namespace ACN::SDT
